/******************************************************************************
** $Id$
**
** Copyright (C) 2006-2007 ascolab GmbH. All Rights Reserved.
** Web: http://www.ascolab.com
** 
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
** 
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
** 
** Project: OpcUa Wireshark Plugin
**
** Description: Service table and service dispatcher.
**
** This file was autogenerated on 12.2.2007 13:21:42.
** DON'T MODIFY THIS FILE!
**
******************************************************************************/

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <gmodule.h>
#include <epan/packet.h>
#include "opcua_identifiers.h"
#include "opcua_serviceparser.h"

ParserEntry g_arParserTable[] = {
  { 1358, parseHelloWorldRequest }, 
  { 1363, parseHelloWorldResponse }, 
  { 1399, parseSampleTestServiceRequest }, 
  { 1404, parseSampleTestServiceResponse }, 
  { 1409, parseFindServersRequest }, 
  { 1414, parseFindServersResponse }, 
  { 1419, parseGetEndpointsRequest }, 
  { 1424, parseGetEndpointsResponse }, 
  { 1434, parseRegisterServerRequest }, 
  { 1439, parseRegisterServerResponse }, 
  { 1449, parseOpenSecureChannelRequest }, 
  { 1454, parseOpenSecureChannelResponse }, 
  { 1459, parseCloseSecureChannelRequest }, 
  { 1464, parseCloseSecureChannelResponse }, 
  { 1474, parseCreateSessionRequest }, 
  { 1479, parseCreateSessionResponse }, 
  { 1484, parseActivateSessionRequest }, 
  { 1489, parseActivateSessionResponse }, 
  { 1494, parseCloseSessionRequest }, 
  { 1499, parseCloseSessionResponse }, 
  { 1504, parseCancelRequest }, 
  { 1509, parseCancelResponse }, 
  { 1519, parseAddNodesRequest }, 
  { 1524, parseAddNodesResponse }, 
  { 1529, parseAddReferencesRequest }, 
  { 1534, parseAddReferencesResponse }, 
  { 1539, parseDeleteNodesRequest }, 
  { 1544, parseDeleteNodesResponse }, 
  { 1549, parseDeleteReferencesRequest }, 
  { 1554, parseDeleteReferencesResponse }, 
  { 1569, parseBrowsePropertiesRequest }, 
  { 1574, parseBrowsePropertiesResponse }, 
  { 1594, parseBrowseRequest }, 
  { 1599, parseBrowseResponse }, 
  { 1604, parseBrowseNextRequest }, 
  { 1609, parseBrowseNextResponse }, 
  { 1625, parseTranslateBrowsePathsToNodeIdsRequest }, 
  { 1630, parseTranslateBrowsePathsToNodeIdsResponse }, 
  { 1665, parseQueryFirstRequest }, 
  { 1670, parseQueryFirstResponse }, 
  { 1675, parseQueryNextRequest }, 
  { 1680, parseQueryNextResponse }, 
  { 1695, parseReadRequest }, 
  { 1700, parseReadResponse }, 
  { 1745, parseHistoryReadRequest }, 
  { 1750, parseHistoryReadResponse }, 
  { 1760, parseWriteRequest }, 
  { 1765, parseWriteResponse }, 
  { 1800, parseHistoryUpdateRequest }, 
  { 1805, parseHistoryUpdateResponse }, 
  { 1810, parseCallRequest }, 
  { 1815, parseCallResponse }, 
  { 1900, parseCreateMonitoredItemsRequest }, 
  { 1905, parseCreateMonitoredItemsResponse }, 
  { 1920, parseModifyMonitoredItemsRequest }, 
  { 1925, parseModifyMonitoredItemsResponse }, 
  { 1930, parseSetMonitoringModeRequest }, 
  { 1935, parseSetMonitoringModeResponse }, 
  { 1940, parseSetTriggeringRequest }, 
  { 1945, parseSetTriggeringResponse }, 
  { 1950, parseDeleteMonitoredItemsRequest }, 
  { 1955, parseDeleteMonitoredItemsResponse }, 
  { 1960, parseCreateSubscriptionRequest }, 
  { 1965, parseCreateSubscriptionResponse }, 
  { 1970, parseModifySubscriptionRequest }, 
  { 1975, parseModifySubscriptionResponse }, 
  { 1980, parseSetPublishingModeRequest }, 
  { 1985, parseSetPublishingModeResponse }, 
  { 2020, parsePublishRequest }, 
  { 2025, parsePublishResponse }, 
  { 2030, parseRepublishRequest }, 
  { 2035, parseRepublishResponse }, 
  { 2045, parseTransferSubscriptionsRequest }, 
  { 2050, parseTransferSubscriptionsResponse }, 
  { 2055, parseDeleteSubscriptionsRequest }, 
  { 2060, parseDeleteSubscriptionsResponse }

};
const int g_NumServices = sizeof(g_arParserTable) / sizeof(ParserEntry);

/** Service type table */
const value_string g_requesttypes[] = {
 { 1358, "HelloWorldRequest" },
 { 1363, "HelloWorldResponse" },
 { 1399, "SampleTestServiceRequest" },
 { 1404, "SampleTestServiceResponse" },
 { 1409, "FindServersRequest" },
 { 1414, "FindServersResponse" },
 { 1419, "GetEndpointsRequest" },
 { 1424, "GetEndpointsResponse" },
 { 1434, "RegisterServerRequest" },
 { 1439, "RegisterServerResponse" },
 { 1449, "OpenSecureChannelRequest" },
 { 1454, "OpenSecureChannelResponse" },
 { 1459, "CloseSecureChannelRequest" },
 { 1464, "CloseSecureChannelResponse" },
 { 1474, "CreateSessionRequest" },
 { 1479, "CreateSessionResponse" },
 { 1484, "ActivateSessionRequest" },
 { 1489, "ActivateSessionResponse" },
 { 1494, "CloseSessionRequest" },
 { 1499, "CloseSessionResponse" },
 { 1504, "CancelRequest" },
 { 1509, "CancelResponse" },
 { 1519, "AddNodesRequest" },
 { 1524, "AddNodesResponse" },
 { 1529, "AddReferencesRequest" },
 { 1534, "AddReferencesResponse" },
 { 1539, "DeleteNodesRequest" },
 { 1544, "DeleteNodesResponse" },
 { 1549, "DeleteReferencesRequest" },
 { 1554, "DeleteReferencesResponse" },
 { 1569, "BrowsePropertiesRequest" },
 { 1574, "BrowsePropertiesResponse" },
 { 1594, "BrowseRequest" },
 { 1599, "BrowseResponse" },
 { 1604, "BrowseNextRequest" },
 { 1609, "BrowseNextResponse" },
 { 1625, "TranslateBrowsePathsToNodeIdsRequest" },
 { 1630, "TranslateBrowsePathsToNodeIdsResponse" },
 { 1665, "QueryFirstRequest" },
 { 1670, "QueryFirstResponse" },
 { 1675, "QueryNextRequest" },
 { 1680, "QueryNextResponse" },
 { 1695, "ReadRequest" },
 { 1700, "ReadResponse" },
 { 1745, "HistoryReadRequest" },
 { 1750, "HistoryReadResponse" },
 { 1760, "WriteRequest" },
 { 1765, "WriteResponse" },
 { 1800, "HistoryUpdateRequest" },
 { 1805, "HistoryUpdateResponse" },
 { 1810, "CallRequest" },
 { 1815, "CallResponse" },
 { 1900, "CreateMonitoredItemsRequest" },
 { 1905, "CreateMonitoredItemsResponse" },
 { 1920, "ModifyMonitoredItemsRequest" },
 { 1925, "ModifyMonitoredItemsResponse" },
 { 1930, "SetMonitoringModeRequest" },
 { 1935, "SetMonitoringModeResponse" },
 { 1940, "SetTriggeringRequest" },
 { 1945, "SetTriggeringResponse" },
 { 1950, "DeleteMonitoredItemsRequest" },
 { 1955, "DeleteMonitoredItemsResponse" },
 { 1960, "CreateSubscriptionRequest" },
 { 1965, "CreateSubscriptionResponse" },
 { 1970, "ModifySubscriptionRequest" },
 { 1975, "ModifySubscriptionResponse" },
 { 1980, "SetPublishingModeRequest" },
 { 1985, "SetPublishingModeResponse" },
 { 2020, "PublishRequest" },
 { 2025, "PublishResponse" },
 { 2030, "RepublishRequest" },
 { 2035, "RepublishResponse" },
 { 2045, "TransferSubscriptionsRequest" },
 { 2050, "TransferSubscriptionsResponse" },
 { 2055, "DeleteSubscriptionsRequest" },
 { 2060, "DeleteSubscriptionsResponse" }

};

/** Dispatch all services to a special parser function. */
void dispatchService(proto_tree *tree, tvbuff_t *tvb, gint *pOffset, int ServiceId)
{
    int index = 0;

    while (index < g_NumServices)
    {
        if (g_arParserTable[index].iRequestId == ServiceId)
        {
            (*g_arParserTable[index].pParser)(tree, tvb, pOffset);
            break;
        }
        index++;
    }
}
